#line 2081 "./lpsrc/flx_rtl.pak"
#ifndef __FLX_SYNC_H__
#define __FLX_SYNC_H__

#include "flx_gc.hpp"
#include "flx_dynlink.hpp"
#include "flx_rtl.hpp"
#include <list>

namespace flx { namespace run {

enum fstate_t { terminated, blocked, delegated };
enum fpc_t { next_fthread_pos, next_request_pos };

RTL_EXTERN char const * get_fstate_desc(fstate_t);
RTL_EXTERN char const * get_fpc_desc(fpc_t);

struct RTL_EXTERN gc_profile_t {
  bool debug_allocations;
  bool debug_collections;
  unsigned long compact;
  unsigned long gc_freq;
  unsigned long gc_counter;
  unsigned long collections;
  bool finalise;
  flx::gc::generic::collector_t *collector;

  gc_profile_t (
    bool debug_allocations_,
    bool debug_collections_,
    unsigned long compact_,
    unsigned long gc_freq_,
    bool finalise_,
    flx::gc::generic::collector_t *collector
  );
  ~gc_profile_t();
};

struct RTL_EXTERN sync_state_t {
  bool debug_driver;
  gc_profile_t *gcp;
  std::list<flx::rtl::fthread_t*> *active;
  flx::rtl::fthread_t *ft;
  flx::rtl::_uctor_ *request;
  fpc_t pc;
  fstate_t fs;
  sync_state_t (
    bool debug_driver_,
    gc_profile_t *gcp_,
    std::list<flx::rtl::fthread_t*> *active_
  );
  void frun();
};

}}

#endif
